package circles;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JFrame;
import javax.swing.JTable;

public class BasicGUI extends JFrame {

    int width = 500;

    int height = 500;

    //nasledjuje obican JPanel, jer su 
    //nam potrebne neke specificne kolekcije
    //i mogucnosti u paint metodu
    CirclePanel circlePanel;
    //tabela sa informacijama o krugu, 
    //prve dve kolone su x,y koord. centra kruga
    //treca je poluprecnik
    JTable circleTable;

    public BasicGUI() {

	setPreferredSize(new Dimension(width, height));
	center();

	setLayout(new BorderLayout());
	addControls();

	pack();
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	setVisible(true);
    }

    void addControls() {
	
	circleTable=new JTable();
	//za model koristimo nasledjenu varijantu
	//klase DefaultTableModel
	CircleTableModel model=new CircleTableModel();
	circleTable.setModel(model);
	getContentPane().add(circleTable, BorderLayout.SOUTH);
	
	circlePanel = new CirclePanel(model);
	getContentPane().add(circlePanel, BorderLayout.CENTER);
	//osluskivaci misa su potrebni za pritisak, kada 
	//se fiksira centar kruga, i otpustanje da se 
	//zavrsi sa definisanjem precnika
	circlePanel.addMouseListener(new MouseAdapter() {
	    @Override
	    public void mousePressed(MouseEvent e) {
		super.mousePressed(e);
		circlePanel.c = e.getPoint();
		circlePanel.temp = null;
	    }

	    @Override
	    public void mouseReleased(MouseEvent e) {
		super.mouseReleased(e);
		circlePanel.temp=e.getPoint();
		Circle circle=Circle.getCircle(circlePanel.c, circlePanel.temp);
		CircleTableModel model=(CircleTableModel)circleTable.getModel();
		model.addCircle(circle);
		circlePanel.currentCircle=null;
	    }
	});

	//pokretni osluskivac misa nam sluzi da hvata
	//dogadjaj povlacenja misa, kada odredjujemo
	//velicinu poluprecnika kruga
	circlePanel.addMouseMotionListener(new MouseAdapter() {
	    @Override
	    public void mouseDragged(MouseEvent e) {
	        super.mouseDragged(e);
	        circlePanel.temp=e.getPoint();
	        //za aktuelnu koordinatu i centar kreiramo
	        //privremeni krug
		Circle circle=Circle.getCircle(circlePanel.c, circlePanel.temp);
		circlePanel.currentCircle=circle;
		circlePanel.repaint();
	    }
	});
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
	BasicGUI gui = new BasicGUI();
    }

    void center() {
	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width - width) / 2, (d.height - height) / 2);
    }

}
