package circles;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

public class CirclePanel extends JPanel implements TableModelListener{

    Point c;
    Point temp;
    Circle currentCircle;
    CircleTableModel model;
    
    public CirclePanel(CircleTableModel model) {
	this.model=model;
	//za table model postavljamo da CirclePanel
	//osluskuje njegove promene. 
	//dakle, kada se desi neka promena u modelu
	//koja se oglasava metodima fireTable...
	//svi oni koji osluskuju table model,
	//izvrsavaju svoj tableChanged metod
	model.addTableModelListener(this);
    }
    
    @Override
    public void tableChanged(TableModelEvent e) {
	//na svaku promenu u modelu,
	//radimo samo repaint. 
	//ovo bi naravno moglo da se radi
	//i efikasnije, da se npr. menja samo 
	//deo panela gde se nalazi promenjeni
	//ili dodati krug, ali...
        repaint();
    }
    
    @Override
    public void paint(Graphics g) {
	//ovde vrsimo iscrtavanje svih
	//krugova, trenutni objekat
	//ukoliko ga korisnik upravo
	//iscrtava bojimo drugacijom bojom
        super.paint(g);
        g.setColor(Color.blue);
        for(Circle c: model.circles){
            c.drawSelf(g);
        }
        g.setColor(Color.red);
        if(currentCircle!=null)
            currentCircle.drawSelf(g);
    }
}
