package circles;

import java.util.Vector;

import javax.swing.table.DefaultTableModel;

public class CircleTableModel extends DefaultTableModel {

    //kolekcija sa krugovima
    Vector<Circle> circles = new Vector<Circle>();

    void addCircle(Circle circle){
	//na svako dodavanje novog kruga
	//u kolekciju moramo da obavestimo
	//sve one koji su zainteresovani za
	//promene u modelu o tome. 
	//u nasem slucaju samo se CirclePanel
	//registrovao za te promene, jer
	//u skladu sa tim treba da iscrta
	//novi krug
	circles.add(circle);
	fireTableRowsInserted(circles.size()-1, circles.size());
    }
    
    @Override
    public Object getValueAt(int row, int column) {
	Circle c=  circles.get(row);
	    
	switch(column){
	case 0:
	    return c.cx;
	case 1:
	    return c.cy;
	case 2:
	    return c.r;
	}
	return null;
     }
    
    @Override
    public void setValueAt(Object aValue, int row, int column) {
	//aktivira se u slucaju da korisnik
	//hoce da edituje celije u tabeli
	Circle c=  circles.get(row);  
	switch(column){
	case 0:
	    c.cx=Integer.parseInt(aValue.toString());
	    break;
	case 1:
	    c.cy=Integer.parseInt(aValue.toString());
	    break;
	case 2:
	    c.r=Integer.parseInt(aValue.toString());
	    break;
	}
	//nakon promene informacija u tabeli,
	//tj. kolekciji sa krugovima, treba
	//da se azurira i panel sa krugovima.
	//iz tog razloga ispaljujemo dogadjaj,
	//na koji ce odreagovati svi zainteresovani,
	//u nasem slucaju to je samo CirclePanel.
	fireTableCellUpdated(row, column);
    }
    
    @Override
    public int getColumnCount() {
        return 3;
    }
    
    @Override
    public int getRowCount() {
	if(circles!=null)
	    return circles.size();
	return 0;
    }
}
